/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.viewlets.web.client.internal.MemberInfoClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function(){

/*
 * Aliases
 */
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;

/*
 * Constants
 */
var SERVICE_ID = "com.ibm.team.dashboard.viewlets.service.internal.members.IMemberInfoService";

/* Cache all the role descriptions fo reach process area to avoid repeated server calls */
var _processAreas = new Array();

com.ibm.team.dashboard.viewlets.web.client.internal.MemberInfoClient = {

	/* void */ getMemberInfo: function(/* string[] */ itemIds, /* ServiceResponseHandler */ srh, /* ServiceTracker */ tracker) {
		var params = {itemIds: itemIds};
		this._invoke("getMemberInfo", params, srh, false, tracker);
	},
	
	/* void */ getRoleDescription: function(/* string */ roleId, /* string */ processAreaScope, /* string */ processAreaItemId, /* ServiceResponseHandler */ srh, /* ServiceTracker */ tracker) {
		if (_processAreas[processAreaItemId] && _processAreas[processAreaItemId][roleId]) 
			srh.doCallback(_processAreas[processAreaItemId][roleId]);
		var serviceObj = {
			success: function(/* string */description){
				if (description) {
					if (!_processAreas[processAreaItemId]) 
						_processAreas[processAreaItemId] = new Array();
					_processAreas[processAreaItemId][roleId] = description;
					srh.doCallback(description);
				}
				else 
					srh.doCallback();
			},
			failure: function(error){
				srh.doErrorCallback(error);
			}
		};
		var srh2 = new ServiceResponseHandler(serviceObj, "success", "failure");
		var params = {roleId: roleId, processAreaScope: processAreaScope, processAreaItemId: processAreaItemId};
		this._invoke("getRoleDescription", params, srh2, false, tracker);
	},

	/*
	 * Invokes a service call.
	 */
	/* void */ _invoke: function(/* string */ method, /* object */ params, /* ServiceResponseHandler */ srh, /* boolean */ post, /* ServiceTracker */ tracker) {
		var req = new ServiceRequest(SERVICE_ID, method, params);
		if (tracker) {
			tracker.register(req, srh);
		}
		TeamServerClient.invokeService(req, srh);

		/*var request = {
		var request = {
			url: URL_PREFIX + method,
			content: params,
			handleAs: "json",
			headers: {
				accept: "text/json"
			},
			handle: function(response, ioArgs) {
				if (response instanceof Error) {
					console.error(response);
					srh.doErrorCallback(response);
				}
				else {
					var returnValue= response["soapenv:Body"].response.returnValue;
					result= null;
					if (returnValue.values) {          // array of EMF objects 
						result= returnValue.values;
					} else if (returnValue.value) {    // single EMF object
						result= returnValue.value;
					} else if (returnValue.dataArgs) { // data query
						result= _demarshallDataQuery(returnValue.dataArgs);
					}
					srh.doCallback(result);
				}
			}
		};
		if (post) {
			jazz.client.xhrPost(request);
		}
		else {
			jazz.client.xhrGet(request);
		}*/
	}
};

})();