/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.viewlets.ui.PagedTableViewlet");

dojo.require("com.ibm.team.dashboard.web.ui.PagedTableViewlet");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.rational.cm.web.viewlets.ui", "ViewletMessages");

(function(){
	
dojo.declare(
	"com.ibm.rational.cm.web.viewlets.ui.PagedTableViewlet",
	com.ibm.team.dashboard.web.ui.PagedTableViewlet,
{
	constructor: function(){
		messages = this.messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.viewlets.ui", "ViewletMessages");
	},
	
	getNoQueryMessage: function(){
		if(!this._noQueryMsg){
			this._noQueryMsg = messages.NoQuery; // make it overridable
		}
		var site = this.getSite();
		var _noQuery = this._noQuery;
		if(!_noQuery){
			var doc = dojo.doc;
			_noQuery = this._noQuery = doc.createElement("DIV");
			_noQuery.appendChild(doc.createTextNode(this._noQueryMsg + " "));
			var a = doc.createElement("A");
			dojo.attr(a, {
				href: "javascript:void(0);",
				innerHTML: messages.SelectQuery,
				onclick: function(e){
					dojo.stopEvent(e);
					site.toggleSettings();
				}
			});
			_noQuery.appendChild(a);
		}
		site.setSecondaryTitle("");
		return _noQuery;		
	},
	
	getNoHitsMessage: function(){
		if(!this._noRecord){
			// IMPORTANT! don't remove the first argument of 'inherited'
			this._noRecord = this.inherited("getNoResultsMessage", arguments);
		}
		return this._noRecord;
	},
	
	_totalResultsChanged: function(){
		this.updateTotalPageFooter();
		var totalResults = this.getResultCount();
		var str = (totalResults >= 0) ? "(" + totalResults + ")" : "";
		this.getSite().setSecondaryTitle(str);
	},
	
	// User-overridable function to destroy details widget etc.
	clearRows: function(){},

	/*
	 * Override PagedTableViewlet
	 */
	onRefresh: function(){
		this.clearRows();
	},
	
	destroy: function(){
		this.clearRows();
		this.inherited(arguments);
	}
});
	
})();