/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.AdminNavigator");

dojo.require("com.ibm.team.reports.web.ui.internal.AdminItemWidget");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() { // module container

/**
 * Widget to display admin options.
 */
dojo.declare("com.ibm.team.reports.web.ui.internal.AdminNavigator",	[dijit._Widget, dijit._Templated], {
		templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/AdminNavigator.html"),
		
		constructor: function(args) {
			this.controller = args.controller;
			this.pages = args.pages;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
			this._childItems = [];			
		},

		postCreate: function() {
			com.ibm.team.reports.web.ui.internal.AdminNavigator.superclass.postCreate.apply(this);
			for (var i = 0; i < this.pages.length; i++) {
				var page = this.pages[i];
				this._addAdminLink(page);
			}
		},

		/**
		 * Adds a link to the widget.
		 */
		_addAdminLink: function(page) {
			var itemWidget = new com.ibm.team.reports.web.ui.internal.AdminItemWidget({page: page, parentWidget: this, controller: this._controller});
			this.adminListDiv.appendChild(itemWidget.domNode);
			this._childItems[this._childItems.length] = itemWidget;
		},
		
		setSelection: function(id) {
			for (var i = 0; i < this._childItems.length; i++) {
				var itemWidget = this._childItems[i];
				if (itemWidget.page.id == id) {
					itemWidget.setSelected(true);
					selected = true;
				} else {
					itemWidget.setSelected(false);
				}
			}
		},
		
		_linkDivMouseOverHandler: function(e) {
			e.preventDefault();
			e.target.className = "admin-div-selected";
		},
		
		_linkDivMouseOutHandler: function(e) {
			e.preventDefault();
			if (this._isSelected) {
				e.target.className = "admin-div-selected";
			} else {
				e.target.className = "admin-div-unselected";
			}
		}		
	}
);

})();