/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.build.web.ui.internal.Constants");

(function() {

/*
 * Build web ui constants.
 */
com.ibm.team.build.web.ui.internal.Constants = {

	REPOSITORY_TYPE: "com.ibm.team.repository.typeName",	
	/*
	 * The summary type of build result's representation.
	 */		
	COMPILE_SUMMARY: "com.ibm.team.build.rest.CompileSummaryDTO",
	JUNIT_SUMMARY: "com.ibm.team.build.rest.JUnitSummaryDTO",
	/*
	 * The row type of build result's compilation info in tree table.
	 */	
	COMPILE_COMPONENT_ROW: "com.ibm.team.build.rest.CompileComponentDTO", 
	COMPILE_PACKAGE_ROW: "com.ibm.team.build.CompilePackage", 
	COMPILE_SOURCEFILE_ROW: "com.ibm.team.build.CompileSource", 
	/*
	 * The column type of build result's compilation info in tree table.
	 */		
	COMPILE_ERRORS_COLUMN: "compilations.column.errors",
    COMPILE_WARNINGS_COLUMN: "compilations.column.warnings", 
    COMPILE_COMPONENT_NAME_COLUMN: "compilations.column.componentname", 
    COMPILE_PACKAGE_NAME_COLUMN: "compilations.column.packagename", 
    COMPILE_FILE_NAME_COLUMN: "compilations.column.filename",
	/*
	 * The row type of build result's JUnit info in tree table.
	 */	
	JUNIT_COMPONENT_ROW: "com.ibm.team.build.rest.JUnitComponentDTO", 
	JUNIT_SUITE_ROW: "com.ibm.team.build.JUnitTestSuiteContribution", 
	JUNIT_CLASS_ROW: "com.ibm.team.build.JUnitTestClass", 
	JUNIT_CASE_ROW: "com.ibm.team.build.JUnitTestCase",	 
	/*
	 * The column type of build result's JUnit info in tree table.
	 */	
	JUNIT_ERRORS_COLUMN: "junit.column.errors",
    JUNIT_FAILURES_COLUMN: "junit.column.failures", 
    JUNIT_TESTS_COLUMN: "junit.column.tests", 
    JUNIT_COMPONENT_NAME_COLUMN: "junit.column.componentname", 
    JUNIT_SUITE_NAME_COLUMN: "junit.column.suitename", 
    JUNIT_CLASS_NAME_COLUMN: "junit.column.classname",
    JUNIT_CASE_NAME_COLUMN: "junit.column.casename" ,	   
   /*
	 * The content type of build result's JUnit info.
	 */	
    JUNIT_ERROR_CONTENT_TYPE: "error",
    JUNIT_FAILURE_CONTENT_TYPE: "warning"
};

})();
