/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.DashboardError");

dojo.require("dojo.i18n");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

(function() {

var messages;

/*
 * An error widget that appears in the dashboard content area, when
 * something has gone wrong processing a request
 */
dojo.declare("com.ibm.team.dashboard.web.ui.internal.DashboardError",
	[dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/DashboardError.html"),
	
	constructor: function(args) {
		this._message = args.message;
		messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");
		this.title = messages.dashboardErrorTitle;
	},
	
	populate: function() {
		if (this._message)
			this._errorMessage.innerHTML = this._message;
		else
			this._errorMessage.innerHTML = messages.dashboardErrorMessage;
	}
});

})();