/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportParamEditBox");

dojo.require("dojo.i18n");

dojo.require("com.ibm.team.reports.web.ui.internal.ReportParam");
dojo.require("com.ibm.team.reports.web.ui.internal.utils.StringUtils");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {
	
	var StringUtils = com.ibm.team.reports.web.ui.internal.utils.StringUtils;
	
    dojo.declare("com.ibm.team.reports.web.ui.internal.ReportParamEditBox", [com.ibm.team.reports.web.ui.internal.ReportParam], {
        templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportParamEditBox.html"),
		
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
		
		setDefaultValues: function() {
			if (this.parameterDTO.defaultValue) {
				this.editBox.value = StringUtils.stripQuotes(this.parameterDTO.defaultValue);	
			}
		},
		
		getSelectedValues: function() {
			return ["'"+this.editBox.value+"'"];
		},
		
		setValues: function(values) {
			this.editBox.value = StringUtils.stripQuotes(values);
		},
		
		remoteError: function(error) {
			alert(error.message);
		}
		
	});
	
})();
