﻿/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
class YAxis extends Axis {

	public static var Y_AXIS_LABEL_NAME:String = "yaxis_label_mc_";
	
	public static var LABEL_FORMAT:TextFormat = YAxis._initTextFieldFormat();	

	
	public function YAxis() {
		super();
	}

	private static function _initTextFieldFormat():TextFormat {
		var textFieldFormat = new TextFormat();
		textFieldFormat.color = 0x666666;
		textFieldFormat.font = ChartArea.FONT;
		// Each character
		// W X H
		// 6 X 7 pixels
		textFieldFormat.size = 10;
		textFieldFormat.align = "right";
		
		return textFieldFormat;
	}		
	
	public function draw(parentMC:MovieClip, gridData:GridData):Void {
	
		this.mc = parentMC.createEmptyMovieClip("yaxis_mc", parentMC.getNextHighestDepth());		
		this.gridData = gridData;
		
	}
	
	public function drawHDashedLine(startX:Number, startY:Number, endX:Number):Void {
		
		var dashSegmentLength:Number = Axis.DASH_LENGTH + Axis.DASH_SPACE_LENGTH;
		var lineLength:Number = endX - startX;
		var count:Number = Math.floor(lineLength / dashSegmentLength);
		var positionX:Number = startX;
		var step:Number = 0;
		
		this.mc.moveTo(positionX, startY);

		this.mc.lineStyle(Axis.LINE_THICKNESS, Axis.LINE_COLOUR);
		
		for (step = 0; step < count; step++) {
			// Dash
			this.mc.lineTo(positionX + Axis.DASH_LENGTH, startY);
			// Space
			positionX = positionX + Axis.DASH_LENGTH + Axis.DASH_SPACE_LENGTH;
			this.mc.moveTo(positionX, startY);
			
		}
		
		var tail:Number = endX - positionX;
		
		if (tail > 0) {
			var lastPositionX:Number;
			if (tail < Axis.DASH_LENGTH) {
				// Draw a partial dash
				// Exactly aligned with X-Axis
				lastPositionX = endX;
			} else {
				// Draw a full dash
				// Not aligned with X-Axis (slightly shorter)
				lastPositionX = positionX + Axis.DASH_LENGTH;
			}
			this.mc.lineTo(lastPositionX, startY);
		}
	}	
	
	public function destroy():Void {
		super.destroy();
	}		
	
}