/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.build.web.ui.internal.utils.Table");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

(function() {

com.ibm.team.build.web.ui.internal.utils.table = {
	Styles: {
		GOLD: 0,
		BLUE: 1,
		GREY: 2
	}
};
var Styles = com.ibm.team.build.web.ui.internal.utils.table.Styles;

dojo.declare("com.ibm.team.build.web.ui.internal.utils.Table", [dijit._Widget, dijit._Templated], {

	headings: null,
	style: Styles.GREY,

	templatePath: dojo.moduleUrl("com.ibm.team.build.web", "ui/internal/templates/utils/Table.html"),
	
	postCreate: function() {
		this._applyStyle();
		if (this.style != Styles.GREY && !this.noHeadLine) {
			var showLine = true;
		} else {
			this._headerLine.style.display = "none";
		}
		for (var i = 0; i < this.headings.length; i++) {
			var heading = this.headings[i];
			var cell = document.createElement("th");
			dojo.addClass(cell,"headerColumn");
			if (heading.className)
				dojo.addClass(cell, heading.className);
			if (heading.width) {
				cell.width = heading.width;
			}
			cell.innerHTML = heading.label.replace(/ /g,"&nbsp;");
			this._headerRow.appendChild(cell);
			if (showLine) {
				var line = document.createElement("th");
				dojo.addClass(line,"headerColumnLine");
				if (heading.className)
					dojo.addClass(line, heading.className);
				if (heading.width) {
					line.width = heading.width;
				}
				this._headerLine.appendChild(line);
			}
		}
	},
	
	setStyle: function(style) {
		if (this.style == style)
			return;
		dojo.removeClass(this.tbody, this._getStyleClass(this.style));
		dojo.removeClass(this._thead, this._getStyleClass(this.style));
		this.style = style;
		this._applyStyle();
	},
	
	_applyStyle: function() {
		dojo.addClass(this.tbody, this._getStyleClass(this.style));
		dojo.addClass(this._thead, this._getStyleClass(this.style));
	},
	
	_getStyleClass: function(style) {
		switch (style) {
			case Styles.GREY:
				return "table-grey";
			case Styles.GOLD:
				return "table-gold";
			case Styles.BLUE:
				return "table-blue";
		}
	}

});

})();
