/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.build.web.ui.internal.utils.TypeUtil");

dojo.require("com.ibm.team.build.web.ui.internal.Constants");

(function() {

/*
 * Aliases
 */
var Constants = com.ibm.team.build.web.ui.internal.Constants;

var COMPILE_COUNT_COLUMN_TYPES = [Constants.COMPILE_ERRORS_COLUMN, Constants.COMPILE_WARNINGS_COLUMN];
var COMPILE_COMPONENT_COLUMN_TYPES = [Constants.COMPILE_COMPONENT_NAME_COLUMN].concat(COMPILE_COUNT_COLUMN_TYPES);
var COMPILE_PACKAGE_COLUMN_TYPES = [Constants.COMPILE_PACKAGE_NAME_COLUMN].concat(COMPILE_COUNT_COLUMN_TYPES);
var COMPILE_SOURCE_COLUMN_TYPES = [Constants.COMPILE_FILE_NAME_COLUMN].concat(COMPILE_COUNT_COLUMN_TYPES);

var JUNIT_COUNT_COLUMN_TYPES = [Constants.JUNIT_TESTS_COLUMN, Constants.JUNIT_FAILURES_COLUMN,Constants.JUNIT_ERRORS_COLUMN];
var JUNIT_COMPONENT_COLUMN_TYPES = [Constants.JUNIT_COMPONENT_NAME_COLUMN].concat(JUNIT_COUNT_COLUMN_TYPES);
var JUNIT_SUITE_COLUMN_TYPES = [Constants.JUNIT_SUITE_NAME_COLUMN].concat(JUNIT_COUNT_COLUMN_TYPES);
var JUNIT_CLASS_COLUMN_TYPES = [Constants.JUNIT_CLASS_NAME_COLUMN].concat(JUNIT_COUNT_COLUMN_TYPES);
var JUNIT_TESTCASE_COLUMN_TYPES = [Constants.JUNIT_CASE_NAME_COLUMN].concat(JUNIT_COUNT_COLUMN_TYPES);;

/*
 * Public utility methods.
 */
com.ibm.team.build.web.ui.internal.utils.TypeUtil = {
	getColumnTypes: function(rowType){
		var columnTypes = [];
		switch (rowType) {
			case Constants.JUNIT_COMPONENT_ROW:
				columnTypes = JUNIT_COMPONENT_COLUMN_TYPES;
				break;
			case Constants.JUNIT_SUITE_ROW:
				columnTypes = JUNIT_SUITE_COLUMN_TYPES;
				break;
			case Constants.JUNIT_CLASS_ROW:
				columnTypes = JUNIT_CLASS_COLUMN_TYPES;
				break;
			case Constants.JUNIT_CASE_ROW:
				columnTypes = JUNIT_TESTCASE_COLUMN_TYPES;
				break;			
			case Constants.COMPILE_COMPONENT_ROW:
				columnTypes = COMPILE_COMPONENT_COLUMN_TYPES;
				break;
			case Constants.COMPILE_PACKAGE_ROW:
				columnTypes = COMPILE_PACKAGE_COLUMN_TYPES;
				break;
			case Constants.COMPILE_SOURCEFILE_ROW:
				columnTypes = COMPILE_SOURCE_COLUMN_TYPES;
				break;								
		}
		return columnTypes;
	},
	
	getChildrenRowType: function(rowType){
		var childrenRowType = Constants.JUNIT_COMPONENT_ROW;	
		switch (rowType) {
			case Constants.JUNIT_COMPONENT_ROW:
				childrenRowType = Constants.JUNIT_SUITE_ROW;
				break;
			case Constants.JUNIT_SUITE_ROW:
				childrenRowType = Constants.JUNIT_CLASS_ROW;
				break;
			case Constants.JUNIT_CLASS_ROW:
				childrenRowType = Constants.JUNIT_CASE_ROW;
				break;		
		}
		return childrenRowType;
	},
	COMPILE_SOURCE_COLUMN_TYPES: COMPILE_SOURCE_COLUMN_TYPES
};

})();