/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.BooleanAttributePart");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
/*
 * This is a wrapper widget that provides the presentation and value
 * processing for Duration, presented in 
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.BooleanAttributePart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: '<div class="BooleanAttributePart">' +
						'<div dojoAttachPoint="_content" style="position:relative;top:0.3em;left:10px;max-width: 15.6em;"></div>' +
						'</div>',

		postCreate: function() {
			
			this.inputCheckbox = document.createElement("INPUT");
			this.inputCheckbox.type = "checkbox";
			var value = this.workingCopy.getValue({ path: ["attributes", this.attributeId, "id"] });
			this._content.appendChild(this.inputCheckbox);
			this.inputCheckbox.checked =  value == "true" || value === true;
			this.inputCheckbox.defaultChecked = this.inputCheckbox.checked;

			if(this.workingCopy.isGuest()) {
				this.inputCheckbox.disabled="true";
			}
			
			this.inputCheckbox._parentWidget = this.parentWidget;
			this.connect(this.inputCheckbox, "onclick", this._handleChange);
			this.connect(this.inputCheckbox, "onkeyup", this._handleKeyUp);
			this.workingCopy.addListener({
				path: ["attributes", this.attributeId, "id"],
				event: "onchange",
				listener: this,
				functionName: "_handleAttributeChange"
			});

		},
		_handleAttributeChange: function(parms) { /* id */
			this.inputCheckbox.checked = parms.attributeValue;
		},
		_handleKeyUp: function(e) {
			if(e.keyCode == 32) this._handleChange(e)
		},
		_handleChange: function (e) {
			this.workingCopy.setValue({
				path: ["attributes", this.attributeId, "id"],
				attributeId: this.attributeId,
				isInitialization: false,
				value: this.inputCheckbox.checked
			});
			e.target._parentWidget._handleDirtyingEvent(e);
		},
		setReadOnly: function(isReadOnly) {
			this.inputCheckbox.disabled=isReadOnly;
		}
	}
);

})();
