/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.CreatorAttributePart");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.ContributorWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
/*
 * Handle presentation operations pertaining to the owner attribute
 */
(function() {

var ContributorWidget = com.ibm.team.workitem.web.ui.internal.view.layout.ContributorWidget;
var EditorUtil 	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.CreatorAttributePart",
	ContributorWidget,
	{
        constructor: function() {

		},
	postCreate: function()  {
			this._addWorkItemEmailSubjectToModifiers(this._modifiers);
			this.inherited(arguments);
		},
	_addWorkItemEmailSubjectToModifiers: function(modifiers) {
		if(this.workItem && this.workItem.attributes.workItemType && this.workItem.attributes.workItemType.label && this.workItem.id && this.workItem.attributes.summary) {
			modifiers.emailSubject = this.workItem.attributes.workItemType.label + " " + this.workItem.id + ": " + EditorUtil.restoreTags(this.workItem.attributes.summary.content);			
		} else {
			modifiers.emailSubject = this.messages.msgDefaultEMailSubject;
		}
	}
 	}
);

})();
