/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.ProcessAreaListPart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.AnchorAttributePart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.require("com.ibm.team.process.web.ui.internal.ProcessAreaSelectionDialog");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.SubscribersPart");
/*
 * Handle presentation operations pertaining to the owner attribute
 */
(function() {

var EditorUtil 	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.ProcessAreaListPart",
	[com.ibm.team.workitem.web.ui.internal.view.editor.parts.SubscribersPart],
	{
		postCreate: function() {
			this.inherited(arguments);
			dojo.addClass(this.domNode, "nudge-down");
		}, 
		_openChooseDialog: function(e) {
			this._openProcessAreaDialog();
		},
		_openProcessAreaDialog: function() {
			if(!EditorUtil.checkLogin()) return;

			var self= this;
			var params= {
				projects: this.presentation.attributeType == "projectAreaList" ||this.presentation.attributeType == "processAreaList",
				teams: this.presentation.attributeType == "teamAreaList"  ||this.presentation.attributeType == "processAreaList" ,
				allowsMultiple: true,
				parentController: this.parentWidget.parentController  || this.parentWidget,
				parentElement: this.domNode,
				onOk: function(selectedItem, action) {
					self.onProcessOk(selectedItem);
				},
				onClose: function() {
					self.parentController.focus();
				}
			};
			new com.ibm.team.process.web.ui.internal.ProcessAreaSelectionDialog(params);
		},
		onProcessOk: function(process) {
			if(!process) return;
			if(process.project) {
				if(this.presentation.attributeType == "teamAreaList") {
					alert(this.messages.promptSelectTeamArea);
					this._openProcessAreaDialog();
					return;
				}				
			} else {
				if(this.presentation.attributeType == "projectAreaList") {
					alert(this.messages.promptSelectProjectArea);
					this._openProcessAreaDialog();
					return;
				}
			}
			
			var found = false;
			var items = this.workingCopy.getItems({attributeId: this.attributeId});
			if(items) {
				for(var i=0;i<items.length;i++) {
					if(items[i].itemId == process.itemId) {
						found=true;
						break;
					}
				}
			}
			if (found) {
			  var message =  dojo.string.substitute(this.messages.errorProcessAlreadySelected, [process.name]);
			  alert(message); 
			} else {
				this.workingCopy.addItems({
					items: [process],
					attributeId: this.attributeId,
					excludeCreator: false
				});
				this.refresh();
			}
		}
	}
);

})();
