/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.PlanConfigurationPart"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require("com.ibm.team.apt.web.ui.internal.common.UI"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.widgets.InfoWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.ProcessAreaSelectionDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IterationSelectionDialog"); //$NON-NLS-1$

(function() {
	
	var UI= com.ibm.team.apt.web.ui.internal.common.UI;
	var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	var CreatePlanIconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/crt_iteration_plan.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	var $document= document;
//	var bind= dojo.string.substitute;
	
	var Styles= {
		exclude: "exclude",	 //$NON-NLS-1$
		highlight: "Highlight",	 //$NON-NLS-1$
		collapsed: "collapsed",	 //$NON-NLS-1$
		expanded: "expanded"	 //$NON-NLS-1$
	};
	
	dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.PlanConfigurationPart", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		
		__ID_AUTO_ASSIGN: "planTypeAutoAssign", //$NON-NLS-1$
		
		_nlsOwner: Messages.PLAN_CREATE_OWNER,
		_nlsIteration: Messages.ITERATIONPLAN_ITERATION,
		_nlsBrowse: Messages.PLAN_CREATE_BROWSE,
		_nlsAdvanced: Messages.PLAN_CREATE_ADVANCED,
		_nlsPlanType: Messages.ITERATIONPLAN_LABEL_PLAN_TYPE,
		_nlsIncludeAllItem: Messages.PLAN_CREATE_ADVANCED_ALL_ITEMS,
		
		__editData: null,
		__saveAction: null,
		
		constructor: function(params, parent){
			this.__editData= params.editData;
			this.__saveAction= params.saveAction;
		},
		
		templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/templates/PlanConfigurationPart.html"), //$NON-NLS-1$ //$NON-NLS-2$
		
		postCreate: function() {
			this.inherited(arguments);
			
			var img= $document.createElement("img"); //$NON-NLS-1$
			img.src= CreatePlanIconUrl;
			this._nodeIcon.appendChild(img);
			
			new com.ibm.team.apt.web.ui.internal.view.widgets.InfoWidget({label: Messages.PLAN_CREATE_ADVANCED_ALL_ITEMS, text: Messages.PLAN_CREATE_ADVANCED_ALL_ITEMS_EXPLAIN}, this._widgetAllItemDesc);
			
			this.connect(this._widgetName, "onblur", dojo.hitch(this, this._setName)); //$NON-NLS-1$
			
			var toolBar= new com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager();
			toolBar.add(this.__saveAction);
			toolBar.create(this._nodeToolBar);
			this._toolBar= toolBar;
			
			this.connect(this._btnOwner, "onclick", dojo.hitch(this, this._setOwner)); //$NON-NLS-1$
			this.connect(this._btnIteration, "onclick", dojo.hitch(this, this._setIteration)); //$NON-NLS-1$
			
			this.connect(this._nodeAdvancedHeaderTitle, "onclick", dojo.hitch(this, this.__toggleAdvanced)); //$NON-NLS-1$ //$NON-NLS-2$

			var elements= this.__editData.planTypes;
			elements.push({ id: this.__ID_AUTO_ASSIGN, name: Messages.PLAN_CREATE_ADVANCED_AUTO_ASSIGN });
			UI.populateSelect(this._widgetPlanTypes, elements, function(element){return element.name;}, function(element){return element.id;});
			dojo.query("option[value='" + this.__ID_AUTO_ASSIGN + "']", this._widgetPlanTypes).addClass(Styles.highlight);  //$NON-NLS-2$ //$NON-NLS-1$
			this.connect(this._widgetPlanTypes, "onchange", dojo.hitch(this, this._setPlanType)); //$NON-NLS-1$
			this.connect(this._widgetAllItems, "onchange", dojo.hitch(this, this._setAllItems)); //$NON-NLS-1$
			this._update();
		},
		
		_update: function(){
			this._btnIteration.disabled= !this.__editData.processArea;
			this._toolBar.update();
			
			this._widgetName.value= this.__editData.name;
			
			this._nodeOwner.value= null;
			if(this.__editData.processArea) {
				this._nodeOwner.value= this.__editData.processArea.label;
			}
			
			this._nodeIteration.value= null;
			if(this.__editData.iteration){
				this._nodeIteration.value= this.__editData.iteration.label;
			}
			
			var reveal= this.__editData.planTypeId;
			if(!reveal){
				reveal= this.__ID_AUTO_ASSIGN;
			}
			UI.selectReveal(this._widgetPlanTypes, reveal);
			
			this._widgetAllItems.checked= this.__editData.alwaysLoadAllExecutionItems;
		},
		
		_setName: function(evt) {
			this.__editData.name= evt.target.value;
			this._update();
		},
		
		_setOwner: function() {
			var $this= this;
			var getProjectArea= function(processArea) {
				var parent= processArea.getParent();
				return parent != null ? arguments.callee.call(this, parent) : processArea;
			};
			
			var params= {
				allowsMultiple: false,
				projects: true,
				teams: true,
				filterProjectArea: getProjectArea(this.__editData.processArea).itemId,
				selection: this.__editData.processArea.itemId,
				parentController: this,
				parentElement: this.domNode,
				onOk: function(selectedItem, action) {
					
					var projectArea= getProjectArea($this.__editData.processArea);
					
					var selectedProcessArea= (function(processArea, itemId) {
						if(processArea.itemId == itemId){
							return processArea;
						} else {
							var children= processArea.getChildren();
							for(var i= 0; i < children.length; i++) {
								var result= arguments.callee.call(this, children[i], itemId);
								if(result)
									return result;
							}
							return null;
						}
					})(projectArea, selectedItem.itemId);
					
					if(!$this.__manualPlanTypeId)
						$this.__editData.planTypeId= null;
					
					var timelines= dojo.isFunction(selectedProcessArea.getDevLines) ? selectedProcessArea.getDevLines() : [selectedProcessArea.getDevLine()];
					var resetIteration= Boolean($this.__editData.iteration) && (function(items){
						for(var i= 0; i < items.length; i++) {
							var item= items[i];
							if($this.__editData.iteration.itemId === item.itemId){
								return false;
							} else {
								var children= dojo.isFunction(item.getChildren) ? item.getChildren() : dojo.isFunction(item.getIterations) ? item.getIterations() : [];
								var result= arguments.callee.call(this, children);
								if(!result)
									return false;
							}
						}
						return true;
					})(timelines);
					if(resetIteration)
						$this.__editData.iteration= null;
					
					$this.__editData.processArea= selectedProcessArea;
					$this._update();
				},
				onClose: function() {
					
				}
			};
			new com.ibm.team.process.web.ui.internal.ProcessAreaSelectionDialog(params);
		},
		
		_setIteration: function() {
			var $this= this;
			var timelines= dojo.isFunction(this.__editData.processArea.getDevLines) ? this.__editData.processArea.getDevLines() : [this.__editData.processArea.getDevLine()];
			var data= [];
			(function(items, result){
				for(var i = 0; i< items.length; i++) {
					var item= items[i];
					var hasDeliverable= (function(item){
						if(item.hasDeliverable === undefined){
							return true;
						} else if(item.hasDeliverable){
							return true;
						} else {
							var children= item.getChildren();
							for(var j= 0; j < children.length; j++) {
								var result= arguments.callee.call(this, children[j]);
								if(result)
									return true;
							}
							return false;
						}
					})(item);
					if(hasDeliverable){
						var obj= {};
						obj.source= item;
						obj.itemId= item.itemId;
						obj.label= item.label;
						var children= dojo.isFunction(item.getChildren) ? item.getChildren() : dojo.isFunction(item.getIterations) ? item.getIterations() : []; 
						if(children && children.length > 0){
							obj.children= [];
							arguments.callee.call(this, children, obj.children);
						}
						result.push(obj);
					}
				}
			})(timelines, data);
			
			var currentIterations= [];
			for(var i = 0; i < timelines.length; i++) {
				var currentIteration= timelines[i].getCurrentIteration();
				if(currentIteration)
					currentIterations.push(currentIteration);
			}
			var selection= [].concat(currentIterations);
			if($this.__editData.iteration)
				selection.push($this.__editData.iteration);
			
			var params= {
				data: data,
				selection: selection,
				parentController: this,
				parentElement: this.domNode,
				onOk: function(selectedItem){
					if(!$this.__manualPlanTypeId)
						$this.__editData.planTypeId= null;
					$this.__editData.iteration= Boolean(selectedItem) && selectedItem.source instanceof com.ibm.team.process.common.Iteration ? selectedItem : null;
					$this._update();
				},
				getIconClass: function(obj) {
					if(obj.source instanceof com.ibm.team.process.common.Iteration){
						if(obj.source.backlog) {
							return "iterationBacklogIcon"; //$NON-NLS-1$
						} else if(dojo.indexOf(currentIterations, obj.source) != -1){
							return "iterationCurrentIcon"; //$NON-NLS-1$
						} else {
							return "iterationIcon"; //$NON-NLS-1$
						}
					} else {
						return "timelineIcon"; //$NON-NLS-1$
					}
				},
				getModelId: function(item) {
					return item.itemId;
				}
			};
			new com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IterationSelectionDialog(params);
		},
		
		_setPlanType: function(evt) {
			this.__editData.planTypeId= evt.target.value != this.__ID_AUTO_ASSIGN ? evt.target.value : null;
			this.__manualPlanTypeId= true;
			this._update();
		},
		
		_setAllItems: function(evt) {
			this.__editData.alwaysLoadAllExecutionItems= evt.target.checked;
			this._update();
		},
		
		// ---- helper -----------------------------------------------------------------------------------------------------
		
		__manualPlanTypeId: false,
		
		__toggleAdvanced: function(evt) {
			dojo.stopEvent(evt);
			dojo.toggleClass(this._nodeAdvanced, Styles.exclude);
			if(!this.__hidesAdvanced()){
				this._update();
				dojo.removeClass(this._nodeAdvancedHeaderTwisty, Styles.collapsed);
				dojo.addClass(this._nodeAdvancedHeaderTwisty, Styles.expanded);
			} else {
				dojo.removeClass(this._nodeAdvancedHeaderTwisty, Styles.expanded);
				dojo.addClass(this._nodeAdvancedHeaderTwisty, Styles.collapsed);
			}
		},
		
		__hidesAdvanced: function(){
			return dojo.hasClass(this._nodeAdvanced, Styles.exclude);
		},
		
		__sentinel: null // terminates this class definition
});

})();
