/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.NewWorkItemAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.ImageClient"); //$NON-NLS-1$

(function() {
	
var ImageClient				= com.ibm.team.apt.web.client.internal.ImageClient;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.NewWorkItemAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {
	
	_viewModel: null,
	_workItemType: null,
	_movePolicy: null,
	
	constructor: function(viewModel, workItemType, itemMovePolicy, viewerItem, location) {
		this._viewModel= viewModel;
		this._workItemType= workItemType;
		this._movePolicy= itemMovePolicy;
		this._viewerItem= viewerItem;
		this._location= location;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "new.planItem." + this._workItemType.itemId + "." + this._location; //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	getName: function() {
		return this._workItemType.label;
	},
	
	getIconUrl: function() {
		return this._workItemType.iconURL ? ImageClient.getImageUrl(this._workItemType.iconURL) : null;
	},
	
	canHandle: function() {
		if (this._viewerItem && this._viewerItem.getViewEntry().isDisposed())
			return false;
		
		var target= this.__findTarget();
		return target && this._movePolicy.canCreate(target, this._workItemType, this._location);
	},
	
	handle: function() {
		return this._movePolicy.create(this.__findTarget(), this._workItemType, this._location);
	},

	// --- implementation ------------------------------------
	
	__findTarget: function() {
		if (this._viewerItem)
			return this._viewerItem.getViewEntry();
		return this._viewModel.readModel(function(readAccessor) {
			var root= readAccessor.getRootEntry();
			var n= readAccessor.getEntryNavigator(true);
			var children= n.childEntries(root);
			if (children.length > 0 && children[0].getElement() instanceof com.ibm.team.apt.ui.structure.GroupElement)
				return children[0];
			return root;
		}, this);
	},
			
	__sentinel: null // terminates this class definition
});

})();
