/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IntegerSelectionDialog"); //$NON-NLS-1$

dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var bind= dojo.string.substitute;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IntegerSelectionDialog", null, { //$NON-NLS-1$
	
	constructor: function(params){
		var widgetParams = { primaryTitle: bind(MSGS.DIALOGS_INTEGER_SELECTION_TITLE, [params.attributeName]) };

		var onOk= dojo.hitch(this, function(attributes) {
			this.floatingPane.close();
			params.onOk({value: this.contentWidget.value});
		});
		
		var onCancel= dojo.hitch(this, function(attributes) {
			this.floatingPane.close();
		}); 
		
		this.contentWidget= new com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IntegerSelectionDialogContent({
			onOk: onOk,  
			onCancel: onCancel,
			attributeName: params.attributeName,
			value: params.attributeValue
		});
		widgetParams.contentNode = this.contentWidget.domNode;
		this.floatingPane = new jazz.ui.Dialog(widgetParams); 
		this.contentWidget.init();
	}
	
});

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IntegerSelectionDialogContent", //$NON-NLS-1$
	[dijit._Widget, dijit._Templated], {
	
	templateString: '<div style="padding: 1em 1em 1em 1em;">' + //$NON-NLS-1$
						'<div dojoAttachPoint="_contentNode" style="height: 20em; background-color: #FFFFFF; border: 1px solid #CCCCCC;"></div>' + //$NON-NLS-1$
						'<div style="padding: 1em 0em; float: right;">' + //$NON-NLS-1$
						'<button dojoAttachPoint="_okCmd">OK</button>' + //$NON-NLS-1$
							'<button dojoAttachPoint="_cancelCmd">Cancel</button>' + //$NON-NLS-1$
						'</div>' + //$NON-NLS-1$
					' </div>', //$NON-NLS-1$
	
	constructor: function(params){
		this._onOk= params.onOk;
		this._onCancel= params.onCancel;
		this._attributeName= params.attributeName;
		this._value= params.value;
	},
	
	postCreate: function() {
		this.connect(this._okCmd, "onclick", dojo.hitch(this, function() { //$NON-NLS-1$
			this.value= this._input.value;
			this._onOk();
		}));
		this.connect(this._cancelCmd, "onclick", this._onCancel); //$NON-NLS-1$
		
		var label= document.createElement("span"); //$NON-NLS-1$
		label.innerHTML= this._attributeName + ': '; //$NON-NLS-1$
		this._contentNode.appendChild(label);
		
		this._input= document.createElement("input"); //$NON-NLS-1$
		this._input.type= "text"; //$NON-NLS-1$
		this._input.value= this._value;
		this._contentNode.appendChild(this._input);
		
		this._okCmd.disabled= true;
		
		this.connect(this._input, "onkeypress", dojo.hitch(this, function(e) { //$NON-NLS-1$
			try {
				var inputValue= this._input.value + e.keyChar;
				var value= parseInt(inputValue, 10);
				if (value == inputValue){
					this._okCmd.disabled= false;
				} else {
					this._okCmd.disabled= true;
				}
			} catch (e) {
				this._okCmd.disabled= true;	
			}
		}));
	},
	
	init: function() {
	}
	
});

})();
