/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

 // Use the jslint 'good things' default with the exception of: nomen: false (don't check variable names since dijit api uses _ which is against jslint rules) and forin
 /*jslint white: true, onevar: true, browser: true, undef: true, nomen: false, eqeqeq: true, plusplus: true, bitwise: true, regexp: true, strict: true, newcap: true, immed: true */
 /*global com, dijit, dojo, dojox, net, window */
 "use strict";
 
dojo.provide("com.ibm.team.scm.web.ui.internal.widgets.resourcesEditor.NewFolderItem");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("dojo.io.iframe");
dojo.require("dijit.form.TextBox");

dojo.require("dojo.i18n");
dojo.require("dijit._base.scroll");
dojo.require("dojox.data.dom");
dojo.require("com.ibm.team.scm.web.client.util");
dojo.require("com.ibm.team.scm.web.client.internal.ScmClient");
dojo.require("dojox.string.BidiComplex");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.requireLocalization("com.ibm.team.scm.web.internal", "Messages");

(function () {
	var ScmUtil, ScmClient, PlatformUI, ServiceResponseHandler;
	ScmUtil	= com.ibm.team.scm.web.client.util;
	ScmClient = com.ibm.team.scm.web.client.internal.ScmClient;
	PlatformUI = net.jazz.ajax.ui.PlatformUI;
	ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	
	/**
	 * Widget to get the name of a new folder.
	 */
	dojo.declare(
			"com.ibm.team.scm.web.ui.internal.widgets.resourcesEditor.NewFolderItem", 
			[dijit._Widget, dijit._Templated, dijit._Contained], {
		templatePath: dojo.moduleUrl("com.ibm.team.scm.web", "ui/internal/widgets/resourcesEditor/templates/NewFolderItem.html"),
		widgetsInTemplate : true,		
		constructor: function (params) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.scm.web.internal", "Messages");
			this.labelFolderName = this.messages.NewFolderItem_labelFolderName;				
		},
		postCreate: function () {
			var that;
			that = this;
			this.connect(this._folderName, "onKeyUp", function (evt) {
				// Update save button - if user sets an empty name it is disabled
				that.getParent().onRefreshed();
			});	
		},
		showWidget: function () {
		},
		getFolderName: function () {
			return this._folderName.attr("value");
		},
		isSave: function () {
			// widget isn't ready yet
			if (!this.domNode) {
				return false;
			}
			// Empty names not allowed
			if (this._folderName.attr("value").length === 0) {
				return false;
			}
			return true;
		}
		
	}
	);
}());