/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2007, 2008. All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
 
dojo.provide("com.ibm.rational.cm.web.ui.view.record.CqCustomizeContent");

dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.rational.cm.web.ui", "cqRecordStrings");

dojo.declare(
	"com.ibm.rational.cm.web.ui.view.record.CqCustomizeContent",
	[dijit._Widget, dijit._Templated],
{
	categories: [],
	tableContainer: null,
	_messages: null,
	templateString: "<table dojoAttachPoint='containerNode' class='cqCustomDialogTable'><tr><td>" +
						"<div class='container' dojoAttachPoint='tableContainer' style='width: 300px; height: 300px; overflow: auto;'>" +
						"</div></td><td align='left' valign='top' style='position:relative'>" +
						"<button dojoAttachEvent='onclick:onSelectAll' style='width:100%'>${_messages.customize_selectall}</button><br>" +
						"<button dojoAttachEvent='onclick:onDeselectAll' style='width:100%'>${_messages.customize_deselectall}</button><br><br>" +
						"<button type='submit' dojoAttachEvent='onclick:onSubmit' style='width:100%'>${_messages.customize_ok}</button><br>" + 
						"<button dojoAttachEvent='onclick:onCancel' style='width:100%'>${_messages.customize_cancel}</button><br><br>" +
						"<a href='javascript:void(0)' style='position:absolute;right:10px;bottom:10px;' onclick='dojo.publish(\"GET_CSH\"," +
							"[{id:\"cqcsh_u_cust_table_view\"}]);' id='cqcsh_u_cust_table_view'> <img style='display:inline;' " +
							 "src='" + net.jazz.ajax._contextRoot + "/cqweb/images/help.gif'/></a>" +
						"</td></tr></table>",		

	postMixInProperties:function(){
		this._messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "cqRecordStrings", this.lang);
		this.inherited("postMixInProperties", arguments);
	},
	
	postCreate: function(){
		this.inherited("postCreate", arguments);
		this.createBody();
	},
	
	createBody: function(){
		this.tableContainer.innerHTML = "";
		var table = dojo.doc.createElement("table");
		table.style.width = "100%";
		this.tableContainer.appendChild(table);
		var tbody = dojo.doc.createElement("tbody");
		table.appendChild(tbody);
		dojo.forEach(this.categories, function(category) {
			var tr = dojo.doc.createElement("tr");
			var td = dojo.doc.createElement("td");
			dojo.addClass(td, "pageCaption");
			td.style.textAlign = "center";
			td.colSpan = "2";
			td.innerHTML = category.name;
			tr.appendChild(td);
			tbody.appendChild(tr);
			dojo.forEach(category.items, function(item) {
				if(item.cqInvisible != "always"){
					var tr = dojo.doc.createElement("tr");
					tbody.appendChild(tr);
					var td = dojo.doc.createElement("td");
					td.style.textAlign = "center";
					tr.appendChild(td);
					var id = dijit.getUniqueId("dijit.form.CheckBox");
					var checkBox = new dijit.form.CheckBox({
							id: id,
							name: item.name,
							value: item.value,
							checked: item.show
					});
					td.appendChild(checkBox.domNode);					
					td = dojo.doc.createElement("td");
					dojo.addClass(td, "fieldCaption");
					tr.appendChild(td);
					var caption = dojo.doc.createElement("label");
					caption.innerHTML = item.label;
					caption.setAttribute("for",id);
					// TODO : need to set "for" attribute
					td.appendChild(caption);
				}
			});
		});
	},
	
	onSelectAll: function(){
		dojo.forEach(this.getDescendants(), function(widget){
			if (widget.setChecked) {
				widget.setChecked(true);
			}
		});
	},
		
	onDeselectAll: function(){
		dojo.forEach(this.getDescendants(), function(widget){
			if (widget.setChecked) {
				widget.setChecked(false);
			}
		});
	},

	onSubmit: function(){
	},

	onCancel: function(){
	}
});