/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.view.resultset.actions.printableVersion");

dojo.require("com.ibm.rational.cm.web._base");

com.ibm.rational.cm.web.ui.view.resultset.actions.showPrintableVersion = function(/* com.ibm.rational.cm.web.ui.view.resultset.ResultSetView */ widget){
	var cq = com.ibm.rational.cm.web;
	var page = window.open(cq.convertUrl("html/blank.html"), "cqPrintableVersion", "width=800,height=600,resizable=yes,scrollbars=yes");
	if(!page){ return; }
	var colData = null;
	var grid = widget.rsGrid;
	cq.xhrGet({
		url: grid.baseUrl,
		content: grid.getXhrContent(true),
		load: function(data, ioArgs){
			if(!page.document){ return; }
			var htmlStr = '';
			page.document.write('<html><head><title>'+widget.title+'</title><style type="text/css">@import "' + net.jazz.ajax._contextRoot + net.jazz.ajax._webuiPrefix + 'com.ibm.rational.cm.web/ui/view/resultset/templates/ResultSetView.css";</style></head><body id="cqExportResultSet"></body></html>');
			page.document.body.id="cqExportResultSet";
			if(data && data.resultSetData){
				var mastershipFieldName = grid.mastershipFieldName;
				htmlStr += '<table><caption>'+widget.title+'</caption><tbody><tr class="cqHeaderRow">';
				
				// add header cells
				var colData = data.resultSetData.colData;
				dojo.forEach(colData, function(col){
					if(!col.isHiddenMastership){
						htmlStr += '<th>' + col.field + '</th>';
					}
				});
				htmlStr += '</tr>';

				// add rows
				dojo.forEach(data.resultSetData.rowData, function(row){
					htmlStr += '<tr>';
					dojo.forEach(colData, function(col){
						if(!col.isHiddenMastership){
							var cellData = row[col.field];
							if(col.dataType == "DateTime"){
								cellData = cq.grid.convertDateTime(cellData);
							}
							htmlStr += '<td>' + cellData + '</td>';
						}
					});
					htmlStr += '</tr>';
				});
				htmlStr += '</tbody></table>';
			}
			page.document.body.innerHTML = htmlStr;
			page.document.close();
			page.print();
		},
		error: function(response, ioArgs){
			page.document.body.innerHTML = "";
			alert(widget.messages.errFetchQuery);
			page.close();
			return;
		},
		handleError: true,
		preventCache: true
	});
}