/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.SyntheticAttribute"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.PlanningAttribute"); //$NON-NLS-1$

(function() {
	
var PlanningAttribute				= com.ibm.team.apt.client.PlanningAttribute;

dojo.declare("com.ibm.team.apt.client.SyntheticAttribute", PlanningAttribute, { //$NON-NLS-1$
	
	__type: null,
	__name: null,
	__getter: null,
	__setter: null,
	__thisObj: null,
	
	constructor: function(descriptor, getter, setter, type, thisObj) {
		this.__getter= getter;
		this.__setter= setter;
		this.__type= type;
		this.__thisObj= thisObj;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	getValue: function(receiver) {
		if (this.__getter == null) {
			throw new Error("can't read attribute " + this.getId()); //$NON-NLS-1$
		}
		
		if (!(receiver instanceof this.__type))
			return undefined;
		
		return this.__getter.call(this.__thisObj, receiver);
	},
	
	setValue: function(receiver, value) {
		if (this.__setter == null) {
			throw new Error("can't write attribute " + this.getId()); //$NON-NLS-1$
		}

		receiver.getPlanModel().compoundChange(function(builder) {
			builder.changed(receiver, this, this.getValue(receiver), value);
			this.__setter.call(this.__thisObj, receiver, value);
		}, this);
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
