/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.ui.structure.GenericElement"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.ui.structure.GroupElement"); //$NON-NLS-1$

(function() {

var GroupElement					= com.ibm.team.apt.ui.structure.GroupElement;

dojo.declare("com.ibm.team.apt.ui.structure.GenericElement", GroupElement, { //$NON-NLS-1$

	__id: null,
	__label: null,
	__value: null,
	__comperator: null,

	constructor: function(id, label, value, options) {
		this.__id= id;
		this.__label= label;
		this.__value= value;
		
		this.__comperator= (options && options.comperator) || function(o1, o2) { return o1.getLabel().localeCompare(o2.getLabel()); };
		this.__adopt= (options && options.adopt) || null;
		this.__canAdopt= (options && options.canAdopt) || null;
	},

	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;

		return this.__id === other.__id;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	getId: function() {
		return this.__id;
	},

	getLabel: function() {
		return this.__label;
	},

	getValue: function() {
		return this.__value;
	},
	
	canAdopt: function(planElement) {
		return this.__adopt && planElement instanceof com.ibm.team.apt.client.PlanItem && (!this.__canAdopt || this.__canAdopt(planElement));
	},
	
	adopt: function(planItem) {
		this.__adopt(planItem);
	},
	
	compareTo: function(other) {
		return this.__comperator(this, other);
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
